#!/usr/bin/python

import httplib, urllib, re, sys, string, time

debug=1

# Variables
LYRICSDIR=sys.argv[1]
ARTIST=""
TITLE=""
RARTIST=""
RTITLE=""
FILENAME=""
FORCE_RETRIEVE=0

##############
# BROWSER : GOOGLE
##################
def browse(Head,Address):
	global nbimage
	if (debug):
		print("Searching through google.com")
	host = Head
	h = httplib.HTTP(host)
	h.putrequest('GET', Address)
	h.putheader('Host', host)
	h.putheader('User-agent', 'Mozilla')
	h.endheaders()
	returncode, returnmsg, headers = h.getreply()
	foo = h.getfile()
	where=foo.read()
	s = re.search("http.*.>here</A>", where)
	if (s):
		RESULT=string.strip(string.replace(s.group(0),"\">here</A>"," "))
		conn = urllib.urlopen(RESULT)
		data = conn.read()
		f = open (FILENAME+".adv.lyr", 'w')
		f.write (data)
		f.close ()
	f = open (FILENAME+".lyr", 'w')
	f.write ("")
	f.close ()
	sys.exit(0)
	
################
# Read the infos
################
def info():
	global ARTIST
	global TITLE
	global FORCE_RETRIEVE
	f = open(FILENAME+".info", 'rb')
	a=f.readline()
	while (a!=""):
		a=string.replace(string.replace(a,"\n",""),"%0D","\n")
		b=f.readline()
		b=string.replace(string.replace(b,"\n",""),"%0D","\n")
		if (a=="ARTIST"):
			ARTIST=string.rstrip(b)
#			print "This is the artist name"
		if (a=="SONG"):
			TITLE=string.rstrip(b)
#			print "This is the song name"
		if (a=="FORCE_RETRIEVE"):
			FORCE_RETRIEVE=1
#		if (a=="ALBUM"):
#			print "This is the album name"
#		if (a=="YEAR"):
#			print "This is the year"
#		print b
		a=f.readline()
	f.close()


##############
# LYRC.COM.AR
# http://lyrc.com.ar/tema.php?songname=SONGTITLE&artist=ARTISTNAME
##################################################################
def lyrc():
	found=1
	global nbimage
	if (debug>0):
		print "[Lyrc] Searching on lyrc.com.ar ("+ARTIST+"-"+TITLE+")"
	URL="http://lyrc.com.ar/xsearch.php?artist="+string.replace(ARTIST," ","%20")+"&songname="+string.replace(TITLE," ","%20")
	conn = urllib.urlopen(URL)
	data = conn.read()
	conn.close()
	s = re.search("<message>nothing found</message>", data)
	if (s):
		found=0
	if (found==0):
		#Search the links
		f = open (FILENAME+".lyrics.xml", 'w')
		f.close ()
		if (debug>0):
			print "[Lyrc] --> lyrics not found :( ("+ARTIST+"-"+TITLE+")"
		sys.exit(0)
	else:
		# Are there multiple results?
		s = re.findall("<song>", data)
		if (len(s)>1 and FORCE_RETRIEVE==0):
			#YES!
			f = open (FILENAME+".lyrics.xml", 'w')
			data=string.replace(data,"\n<","<") #You shouldn't go do linefeed like that in XML!!!
			data=string.replace(data,"&","&amp;")
			f.write (data)
			f.close ()
			if (debug>0):
				print "[Lyrc] --> multiple lyrics found :S ("+ARTIST+"-"+TITLE+")"
		else:
			#NO, get lyrics
			URL="http://lyrc.com.ar/xsearch.php?artist="+string.replace(ARTIST," ","%20")+"&songname="+string.replace(TITLE," ","%20")+"&act=1"
			conn = urllib.urlopen(URL)
			data = conn.read()
			conn.close()
			f = open (FILENAME+".lyrics.xml", 'w')
			data=string.replace(data,"\n<","<") #You shouldn't go do linefeed like that in XML!!!
			data=string.replace(data,"&","&amp;")
			f.write (data)
			f.close ()
			if (debug>0):
				print "[Lyrc] --> lyrics found :) ("+ARTIST+"-"+TITLE+")"
###############
# The main code

l=len(sys.argv)
r=range(2,l)
global nbimage
nbimage=0
where=0
for i in r:
	BUFF=sys.argv[i]
	if (re.search("__00__", BUFF)):
		where=where+1
	else:
		if (where==0):
			ARTIST=ARTIST+BUFF+" "
		else:
			if (where==1):
				TITLE=TITLE+BUFF+" "
			if (where==2):
				RARTIST=RARTIST+BUFF+" "
			if (where==3):
				RTITLE=RTITLE+BUFF+" "

#Remove ending spaces...
ARTIST=string.rstrip(ARTIST)
TITLE=string.rstrip(TITLE)
FILENAME=LYRICSDIR+ARTIST+" - "+TITLE

if (where>2):
	ARTIST=string.rstrip(RARTIST)
	TITLE=string.rstrip(RTITLE)
info()

if (debug>1):
	print "Artist : "+ARTIST
	print "Song : "+TITLE
	print "Filename (if found) : "+FILENAME+".lyrics.xml"
	if (FORCE_RETRIEVE==1):
		print "Retrieve is forced"

lyrc()
