#!/usr/bin/perl
# -- lyrics upload for lyrc.com.ar
# -- 11/2004 by camico A7 users D07 sourceforge D07 net

use LWP::Simple qw(get);

# =============================================================================
my $DEBUG = 1;
# =============================================================================

my $dir = shift;
my $file = shift;
my $url = shift;
my $html = "";
# -----------------------------------------------------------------------------
DBG( "url: $url" );

$html = get $url;
msg( "Cannot access $url." )
	if not $html;
msg( "You need to fill out these fields: Artist, Title, Album and Lyrics." )
	if( $html !~ /lyric was succesfully added/i );

$html =~ s/<.*?>//gis;
$html =~ s/V O L V E R//i;
$html =~ s/Add lyric//i;
$html =~ s/[\s\n]*$//gm;

msg( $html );

# -----------------------------------------------------------------------------
sub msg {
	my $msg = shift;
	DBG( "answer: $msg" );
	if( not -p "$dir/$file" ) { DBG( "Pipe $dir/$file was closed, exiting..." ); exit; }
	open FIFO, "> $dir/$file" || die "writing to $dir/$file failed: $!";
	print FIFO "$msg\n";
	close FIFO;
	exit;
}

# -----------------------------------------------------------------------------
sub DBG {
    my $str = shift;
    if( $DEBUG ) {
		$str =~ s/\n/\n              /g;
		print "[Lyrc Upload] $str\n";
    }
}
